[changes]
* The JAR file inetslf4j.jar was renamed into inetloggeradapter.jar. It also contains an adapter for Commons Logging
* PDF export: JPEG images in EXIF format now supported
* Memory improvements for images with image key
* Date parsing order optimized to conform the modified date patterns in Java 9
* Login Type "Internal Webserver" is also available if i-net Clear Reports is not running in an application server but if an login filter is used
* Performance optimization for user expander formulas

### HTML Report Viewer
* The HTML Report Viewer will now export reports with more than 100 pages to PDF instead of printing them using the browser function

### i-net Designer
* Support for the Windows setting "Large Fonts" in the i-net Designer added if it is used with Java 9
* Now the user formula can be named the same as Property Formulas
* Remote i-net Designer requires the adhoc plugin
* The Remote Designer now supports the JNLP protocol for a direct start of the JNLP file. The HTTP URL stays available as fallback link

### Task Planner
* If a prompt field of a report supports "Multiple Values" then all default values of the prompt will be added to the array of values

### Servlet
* Servlet Spec was changed to version 3.1 and the class of the login servlet was changed to com.inet.authentication.LoginServlet

[changes:de]
* Die JAR-Datei inetslf4j.jar wurde umbenannt in inetloggeradapter.jar. Sie enthält auch einen Adapter für Commons Logging
* PDF-Export: JPEG-Bilder im EXIF-Format werden jetzt unterstützt
* Speicherverbesserungen für Bilder mit Bildschlüssel
* Datums-Parsing-Reihenfolge optimiert, um den geänderten Datumsmustern in Java 9 zu entsprechen
* Login-Typ "Interner Webserver" ist auch verfügbar, wenn i-net Clear Reports nicht auf einem Applikationsserver läuft, sondern ein Login-Filter verwendet wird
* Leistungsoptimierung für User-Expander-Formeln

### HTML-Berichtsbetrachter
* Der HTML Report Viewer exportiert nun Berichte mit mehr als 100 Seiten als PDF, anstatt sie über die Browserfunktion zu drucken

### i-net Designer
* Unterstützung für die Windows-Einstellung "Große Schriftarten" im i-net Designer hinzugefügt, wenn dieser mit Java 9 verwendet wird
* Die Benutzerformel kann jetzt genauso benannt werden wie die Eigenschaftsformeln
* Remote i-net Designer benötigt das Adhoc-Plugin
* Der Remote Designer unterstützt nun das JNLP-Protokoll für einen direkten Start der JNLP-Datei. Die HTTP-URL bleibt als Fallback-Link verfügbar

### Aufgabenplaner
* Wenn ein Eingabeaufforderungsfeld eines Berichts "Mehrere Werte" unterstützt, werden alle Standardwerte der Eingabeaufforderung zum Wertefeld hinzugefügt

### Servlet
* Servlet Spec wurde auf Version 3.1 geändert und die Klasse des Login-Servlets wurde auf com.inet.authentication.LoginServlet geändert

[bugfixes]
* Multiple issues with the Java 9 release candidate occurred
* PDF export: Some bugs in PDF/A-1b export has been fixed
* XLS / XLSX export:
  * Number property formulas were used although the Decimal number format was used instead of the user defined number format and the property formulas should be disabled. This could result for example in a wrong sign
  * Client timezone was ignored for date time values in the XLSX format
  * "Suppress if Duplicated" does not suppress duplicate fields in some cases
  * Percent format in XLSX format shows 0%
* No cipher suite error with HTTPS connections occurred
* Line height style was only used in first line of wrapped text, if Text Interpretation "HTML(advanced)" was used
* Fix a bug with recursive table joins over multiple data sources (DS-A → DS-B → DS-A). The resulting error message was: "Report Error [1403] Error occurred while fetching data or while using data cache."
* Unhandled Exception "java.lang.InternalError" with message "couldn't create component peer" occurred with Java 8u152
* Clip/alignment of italic right align text with a large italic angle was wrong 
* Word breaking of Thai language in advanced HTML content was wrong. The correct behaviour requires the report locale set to be 'Thai'
* Error "Report Error [1401] Illegal argument for DATE sproc ..." with SP parameter of type DATE occurred
* Error "Could not create font with ID X" occurred if an OTF font was used and the property "Compress Viewer Fonts" in the Configuration Manager dialog "Font" was enabled
* RTF export: 
  * Font names in font table should be written using an East-Asian character set encoding instead of unicode
  * Content on some text boxes not displayed completely if the text box contains a lot of text
* PDF export: Barcode font was too big
* ArrayIndexOutOfBoundsException occurred if facename und familyname arrays have a different lenght
* "The design of the crosstab is too large" occurred with a crosstab in a subreport
* Currency symbol was displayed although the field was suppressed
* If "Underlay Following Section" was enabled for a section in a subreport then it could occur that the subreport was moved to the report report page
* If the URL used in BytesFromFile function returns an 404 error then  "unknown image format" was displayed in executed report. In this case image will be shown as blank
* Exception: "org.bouncycastle.asn1.pkcs.PrivateKeyInfo cannot be cast to org.bouncycastle.openssl.PEMKeyPair" occurred
* Crosstab property "Suppress Row Labes" in "Group Options" does not work for more than one field in crosstab rows, if it is enabled for more than one field in crosstab rows
* Fix problems when NofM and PageCount are used alone in a subreport and not in the main report and hard disk cache is enabled. This can lead to missing pages of the main report and the subreport will miss the output of NofM
* Only the end of a "Can Grow" field was displayed at the 2nd appearance of the field if the field has been continued on a second page
* If an embedded font have different font metrics as the system font with the same name and text interpretation "HTML(Advanced)" was used then the text layout could be broken
* SVGDecoder does not work with Java 9 (or higher): ClassNotFoundException: org.w3c.dom.css.DOMImplementationCSS
* PDF document was not displayed correctly in report
* Decimal number format in XLSX and ODS output format was 0 instead of the correct number
* Fonts of an PDF document embedded in sub report were missing
* Security issue "Cross-Site Scripting" occurred
* ORA-01000: maximum open cursors exceeded - occurred if Oracle JDBC driver was used

### Java Report Viewer
* ClassCastException with custom L&F occurred
* The report viewer set a printer resolution only if Java 9 is used and no printer resolution was set. The bug was fixed in Java 10: [https://bugs.openjdk.java.net/browse/JDK-8186987](https://bugs.openjdk.java.net/browse/JDK-8186987)

### HTML Report Viewer
* If a report page can not be found in the HTML Viewer after refreshing the report (out of range error), the last page of the report will be opened. The viewer will be blocked until the report finishes rendering
* CSV export from the HTML Viewer with custom delimiters set to 'Other' or 'Fixed column width' did not work
* Prompt parameter value was decoded. This was problematic for PropertyChecker implementations
* "Uncaught URIError: URI malformed" or "URIError: malformed URI sequence" occurred if group tree node contains special character like '%' and drill down was used on this node
* Image size increases because original image data was not used

### i-net Designer
* Exception com.inet.cache.internal.CacheLoadException occurred on Unix if there are 2 instances running
* Incorrect error markers occurred in problem finder. This error only occurred for formulas that were using a 'user defined function' when loading a report from the repository
* Fixed the error "cannot access class sun.print.SunAlternateMedia" in the Remote Designer with Java 9
* NullPointerException occurred if a condition in if then operator was not true
* In case of a long list of system fonts the i-net Designer needed a long time to start
* NullPointerException with custom Look & Feel occurred
* Hairline box without background was not printed in the Java output (report preview)

### Task Planner
* Export Properties was missing in "Jobs" dialog "Report" for Excel and Open Document Spreadsheet
* CSV export was missing
* Problems in the task planner with the reporting cache occurred if a previous task execution has produced an error
* It could occur that the TaskPlanner clean up the 'normal' user comparisons
* Default values of Prompt fields were not read from the rpt file
* NumberFormatException: For input string: "<long number>" occurred
* Filename of CSV export with enabled "Data only" property and postscript export was wrong.

### Repository
* MIME type mismatch via SSL connection with strict MIME type checking for Echo2 Modules like Repository Browser 

### Configuration Manager
* Message "Configuration not available. Please reinstall the application" was displayed sometimes while the Configuration Manager web GUI was loading the configuration
* Error "$rootScope.model.activeCategory is undefined" occurred after server restart

### Web Interface
* java.lang.NullPointerException occurred while opening file chooser

[bugfixes:de]
* Mehrere Probleme mit dem Java 9 Release Candidate sind aufgetreten
* PDF-Export: Einige Fehler im PDF/A-1b-Export wurden behoben
* XLS/XLSX-Export:
  * Zahleneigenschaftsformeln wurden verwendet, obwohl das Dezimalzahlenformat anstelle des benutzerdefinierten Zahlenformats verwendet wurde und die Eigenschaftsformeln deaktiviert werden sollten. Dies konnte z.B. zu einem falschen Vorzeichen führen
  * Client-Zeitzone wurde für Datums- und Zeitwerte im XLSX-Format ignoriert
  * "Unterdrücken, wenn doppelt" unterdrückt in manchen Fällen keine doppelten Felder
  * Prozentformat im XLSX-Format zeigt 0% an
* Kein Cipher-Suite-Fehler bei HTTPS-Verbindungen aufgetreten
* Der Stil für die Zeilenhöhe wurde nur in der ersten Zeile des umgebrochenen Textes verwendet, wenn die Textinterpretation "HTML(advanced)" verwendet wurde
* Behebung eines Fehlers bei rekursiven Tabellen-Joins über mehrere Datenquellen (DS-A → DS-B → DS-A). Die resultierende Fehlermeldung war: "Report Error [1403] Error occurred while fetching data or while using data cache."
* Unbehandelte Exception "java.lang.InternalError" mit der Meldung "couldn't create component peer" trat bei Java 8u152 auf
* Clip/Ausrichtung von kursivem, rechtsbündigem Text mit großem Kursivwinkel war falsch
* Wortumbruch der thailändischen Sprache im erweiterten HTML-Inhalt war falsch. Das korrekte Verhalten erfordert, dass das Gebietsschema des Berichts auf 'Thai' eingestellt ist
* Fehler "Report Error [1401] Illegales Argument für DATE sproc ..." mit SP-Parameter vom Typ DATE trat auf
* Fehler "Schriftart mit ID X konnte nicht erstellt werden" trat auf, wenn eine OTF-Schriftart verwendet wurde und die Eigenschaft "Compress Viewer Fonts" im Konfigurationsmanager-Dialog "Schriftart" aktiviert war
* RTF-Export:
  * Schriftartennamen in der Schriftartentabelle sollten mit einer ostasiatischen Zeichensatzkodierung anstelle von Unicode geschrieben werden
  * Inhalt einiger Textfelder wird nicht vollständig angezeigt, wenn das Textfeld viel Text enthält
* PDF-Export: Barcode-Schriftart war zu groß
* ArrayIndexOutOfBoundsException trat auf, wenn die Arrays facename und familyname eine unterschiedliche Länge haben
* "Das Design der Kreuztabelle ist zu groß" trat bei einer Kreuztabelle in einem Teilbericht auf
* Währungssymbol wurde angezeigt, obwohl das Feld unterdrückt war
* Wenn für einen Abschnitt in einem Unterbericht "Unterlegen nach Abschnitt" aktiviert war, konnte es vorkommen, dass der Unterbericht auf die Berichtsseite verschoben wurde
* Wenn die in der Funktion BytesFromFile verwendete URL einen 404-Fehler zurückgibt, wurde im ausgeführten Bericht ein "unbekanntes Bildformat" angezeigt. In diesem Fall wird das Bild als leer angezeigt
* Exception: "org.bouncycastle.asn1.pkcs.PrivateKeyInfo kann nicht in org.bouncycastle.openssl.PEMKeyPair umgewandelt werden" ist aufgetreten
* Kreuztabellen-Eigenschaft "Suppress Row Labes" in "Group Options" funktioniert nicht für mehr als ein Feld in Kreuztabellenzeilen, wenn sie für mehr als ein Feld in Kreuztabellenzeilen aktiviert ist
* Behebung von Problemen, wenn NofM und PageCount nur in einem Unterbericht und nicht im Hauptbericht verwendet werden und der Festplatten-Cache aktiviert ist. Dies kann zu fehlenden Seiten im Hauptbericht führen und der Unterbericht verpasst die Ausgabe von NofM
* Beim 2. Erscheinen eines Feldes "Kann wachsen" wurde nur das Ende des Feldes angezeigt, wenn das Feld auf einer zweiten Seite fortgesetzt wurde
* Wenn eine eingebettete Schriftart eine andere Schriftmetrik als die Systemschriftart mit demselben Namen hat und die Textinterpretation "HTML(Advanced)" verwendet wurde, konnte das Textlayout fehlerhaft sein
* SVGDecoder funktioniert nicht mit Java 9 (oder höher): ClassNotFoundException: org.w3c.dom.css.DOMImplementationCSS
* PDF-Dokument wurde im Bericht nicht korrekt angezeigt
* Dezimalzahlenformat im XLSX- und ODS-Ausgabeformat war 0 anstelle der korrekten Zahl
* Schriftarten eines PDF-Dokuments, das in einen Unterbericht eingebettet ist, fehlten
* Sicherheitsproblem "Cross-Site Scripting" aufgetreten
* ORA-01000: Maximum Open Cursors exceeded - trat auf, wenn der Oracle JDBC-Treiber verwendet wurde

### Java Report Viewer
* ClassCastException mit benutzerdefiniertem L&F aufgetreten
* Der Report Viewer setzte nur dann eine Druckerauflösung, wenn Java 9 verwendet wird und keine Druckerauflösung gesetzt war. Der Fehler wurde in Java 10 behoben: [https://bugs.openjdk.java.net/browse/JDK-8186987](https://bugs.openjdk.java.net/browse/JDK-8186987)

### HTML-Berichtsbetrachter
* Wenn eine Berichtsseite im HTML-Viewer nach dem Aktualisieren des Berichts nicht gefunden werden kann (out of range error), wird die letzte Seite des Berichts geöffnet. Der Viewer wird blockiert, bis der Bericht fertig gerendert ist
* Der CSV-Export aus dem HTML-Viewer mit benutzerdefinierten Trennzeichen, die auf "Andere" oder "Feste Spaltenbreite" eingestellt sind, funktioniert nicht
* Der Wert des Prompt-Parameters wurde dekodiert. Dies war problematisch für PropertyChecker-Implementierungen
* "Ungefangener URIError: URI malformed" oder "URIError: malformed URI sequence" traten auf, wenn ein Gruppenbaumknoten ein Sonderzeichen wie '%' enthielt und ein Drilldown auf diesen Knoten verwendet wurde
* Die Bildgröße erhöht sich, da die ursprünglichen Bilddaten nicht verwendet wurden

### i-net Designer
* Ausnahme com.inet.cache.internal.CacheLoadException trat unter Unix auf, wenn 2 Instanzen laufen
* Falsche Fehlermarkierungen sind im Problemfinder aufgetreten. Dieser Fehler trat nur bei Formeln auf, die beim Laden eines Berichts aus dem Repository eine "benutzerdefinierte Funktion" verwendet haben
* Der Fehler "cannot access class sun.print.SunAlternateMedia" im Remote Designer mit Java 9 wurde behoben
* NullPointerException trat auf, wenn eine Bedingung im if then Operator nicht wahr war
* Bei einer langen Liste von Systemschriften brauchte der i-net Designer sehr lange zum Starten
* NullPointerException bei benutzerdefiniertem Look & Feel aufgetreten
* Hairline-Box ohne Hintergrund wurde in der Java-Ausgabe (Berichtsvorschau) nicht gedruckt

### Aufgaben-Planer
* Export Eigenschaften fehlten im "Jobs" Dialog "Bericht" für Excel und Open Document Spreadsheet
* CSV-Export fehlte
* Probleme im TaskPlanner mit dem Berichts-Cache traten auf, wenn eine vorherige Task-Ausführung einen Fehler produziert hat
* Es konnte vorkommen, dass der TaskPlanner die 'normalen' Benutzervergleiche aufräumte
* Standardwerte von Prompt-Feldern wurden nicht aus der rpt-Datei gelesen
* NumberFormatException: For input string: "<Lange Zahl>" aufgetreten
* Der Dateiname des CSV-Exports bei aktivierter Eigenschaft "Nur Daten" und Postscript-Export war falsch.

### Repository
* MIME-Typ-Fehlanpassung über SSL-Verbindung mit strenger MIME-Typ-Prüfung für Echo2-Module wie Repository Browser

### Konfigurations-Manager
* Die Meldung "Konfiguration nicht verfügbar. Bitte installieren Sie die Anwendung neu" wurde manchmal angezeigt, während die Web-GUI des Konfigurationsmanagers die Konfiguration lud
* Fehler "$rootScope.model.activeCategory ist undefiniert" trat nach einem Server-Neustart auf

### Webschnittstelle
* java.lang.NullPointerException trat beim Öffnen des Dateiauswahlfensters auf

[security]
* Critical Security Update for Help Plugin (CVE-2020-11431)
* Fixed XXE vulnerability for authenticated users with privileges to ad-hoc reporting or remote designer (CVE-2020-12684)
* Fixed multiple XSS vulnerabilities (login was not required).
* Fixed a path traversal vulnerability which allowed access to files within the installation folder and its sub-folders

[security:de]
* Kritisches Sicherheitsupdate für Help Plugin (CVE-2020-11431)
* Behebung einer XXE-Schwachstelle für authentifizierte Benutzer mit Berechtigungen für Ad-hoc-Berichterstattung oder Remote-Designer (CVE-2020-12684)
* Mehrere XSS-Schwachstellen behoben (Anmeldung war nicht erforderlich).
* Behebung einer Path-Traversal-Schwachstelle, die den Zugriff auf Dateien innerhalb des Installationsordners und seiner Unterordner ermöglichte
